<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 07/04/14
 * Time: 15:43
 * To change this template use File | Settings | File Templates.
 */
namespace Scheduler\Facade;
require_once __DIR__ . '/../Util/Macros.php';
require_once __DIR__ . '/../Facade/ParamWindowFacade.php';


use Setforms2\Runtime\ContextVars;

//class PopupBuilder{
/**
 * Class PopupParamsFacade
 *
 * Essa classe controla a aparência do popup scd_popup_params
 *
 * @package Scheduler\Facade
 */
class PopupParamsFacade{


    /**
     * Mostra os campos que são requeridos pelo processo especificado. Esse processso é especificado no
     * campo $processField, da tab (contexto)$context.
     * Como esse valor é acessado como uma variável de contexto, o campo que o contém deve estar preservado assim
     * e pode ser setado via script com tk_set_context_var.
     *
     * (Obs: No funcionamento do Scheduler, essa característica serve para que as configurações do wizard
     * não conflitem com a da tela)
     *
     * @param String $processField
     *  O campo (a variável de contexto).
     * @param String $context
     *  A tab (o contexto em questão).
     */
    public static function setFields($processField="TKU_PROCESS_ID", $context="scd_execprocesso_usuario"){
        //pega todos os campos disponíveis do popup para setá-los invisíveis
        $fieldArray=tk_get_all_fields();

        //esses campos são internos do framework, é melhor não mexer neles
        unset($fieldArray['_ID']);
        unset($fieldArray['_STATE']);
        unset($fieldArray['_CHECKED']);

        \Scheduler\Util\Macros::tk_set_invisible_fields($fieldArray);

        //pega o id do processo escolhido na tela anterior e mostra somente os campos que ele usa
        $processId=tk_get_context_vars($processField, $context);
        $fieldsToSet=\Scheduler\Facade\ParamWindowFacade::getFieldsToSet($processId);

        foreach ($fieldsToSet as $field){
            tk_set_visible_field($field, 'scd_popup_params', 'scd_popup_params');
            tk_set_field_required($field, 'scd_popup_params', 'scd_popup_params');
            if($field==="RECIPIENT") tk_set_visible_field("CONTACTS");
        }
        //guarda os campos que foram ativados para usar depois
        tk_set_env_var("ACTIVE_FIELDS", $fieldsToSet);

        try{
            //pega os parâmetros que estão no campo de parâmetros
            $previousParams=tk_get_context_vars("PROCESS_PARAMS", "scd_execprocesso_usuario");

            //se o popup não foi aberto ainda, retorna null
            //então é necessário setar a variável de contexto para \Scheduler\Facade\ParameterFieldManager::loadParameters()
            //a usa para checar se deve recolocar a string informativa de parâmetros no campo "PARAMETROS"
            if(!empty($previousParams)) tk_set_context_vars("didRun", "scd_execprocesso_usuario", false);
            else tk_set_context_vars("didRun", "scd_execprocesso_usuario", true);

            if ($previousParams!==""){
                //essa string vai receber todos os parâmetros sem campo correspondente, e será colocado em "PARAMETERS"
                $looseFieldString="";

                //$params_decoded=htmlspecialchars_decode($previousParams, ENT_QUOTES);
                $previousParamsArray=json_decode($previousParams, true);
                unset($previousParamsArray["NRORG"]);
                foreach($previousParamsArray as $key=>$value){
//                    $value=htmlspecialchars_decode($value, ENT_QUOTES);
                    if (in_array($key, $fieldsToSet, true)) tk_set_field_value($key, $value);
                    else $looseFieldString.=($key."=".$value."\n");
                }
                $looseFieldString=substr($looseFieldString,0,-1);
                if (!$looseFieldString) $looseFieldString="";
                tk_set_field_value('PARAMETERS',$looseFieldString);
            }
        }
        catch (\Exception $e){
            //no-op
        }

    }

//    public static function getFieldsToSet($context){  //Aqui precisa passar parâmetro
//        $processId=tk_get_context_vars("TKU_PROCESS_ID", $context);
//
//        $processArr=\Scheduler\Entities\TkuProcess::findByTkuProcessId($processId); //acha o processo referido
//        $process=$processArr[0];                                                    // para montar os campos
//
//        $fieldsToSet=explode("," , $process->getProcessParams());
//        $arrayAttribs=Array();
//        foreach ($fieldsToSet as $paramKey=>$param){ //checkForAttribs
//            if (strpos($param, '=')!==false){
//                $attrib=explode("=", $param);
//                $arrayAttribs[$attrib[0]]=$attrib[1];
////                tk_set_env_var($attrib[0], $attrib[1]);
//                unset($fieldsToSet[$paramKey]);
//            }
//        }
//        tk_set_env_var("ATTRIBUTED_PARAMETERS",$arrayAttribs);
//        return $fieldsToSet;
//    }
}

